#include <pthread.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>

int contor = 0;			// Szamlalo
pthread_mutex_t mutcontor = PTHREAD_MUTEX_INITIALIZER;
pthread_cond_t condcontor = PTHREAD_COND_INITIALIZER;
int thid[3] = { 0, 1, 2 };
void *incContor (void *tid);
void *verifContor (void *tid);

main ()
{
  pthread_t th[3];
  int i;

  //a 3 szal letrehozasa
  pthread_create ((pthread_t *) &th[0], NULL, verifContor, (void *)&thid[0]);
  pthread_create ((pthread_t *) &th[1], NULL, incContor, (void *)&thid[1]);
  pthread_create ((pthread_t *) &th[2], NULL, incContor, (void *)&thid[2]);
  
  //varakozas a szalak befejezesere
  for (i = 0; i < 3; i++)
    pthread_join (th[i], NULL);
}

void *incContor (void *tid) {
  int *id = (int *) tid;
  int i; printf ("\nSTART incContor %d\n", *id);
  for (i = 0; i < 7; i++) {
    sleep(random() % 3);
    pthread_mutex_lock (&mutcontor);
    contor++;
    printf("\n incContor: thread %d old contor %d new contor %d", *id, contor - 1, contor);
    if (contor == 12) {
      pthread_cond_signal (&condcontor);
    }
    pthread_mutex_unlock (&mutcontor);
  }
  printf ("\nSTOP incContor %d\n", *id);
}

void *verifContor (void *tid) {
  int *id = (int *)tid;
  printf ("\nSTART verifContor \n");
  pthread_mutex_lock (&mutcontor);
  while (contor <= 12) {
    pthread_cond_wait (&condcontor, &mutcontor);
    printf ("\n verifContor: thread %d contor %d\n", *id, contor);
    break;
  }
  pthread_mutex_unlock (&mutcontor);
  printf ("\nSTOP verifContor \n");
}

/*
START verifContor
START incContor 1
START incContor 2

incContor: thread 2 old contor 0 new contor 1
incContor: thread 2 old contor 1 new contor 2
incContor: thread 1 old contor 2 new contor 3
incContor: thread 2 old contor 3 new contor 4
incContor: thread 1 old contor 4 new contor 5
incContor: thread 2 old contor 5 new contor 6
incContor: thread 2 old contor 6 new contor 7
incContor: thread 2 old contor 7 new contor 8
incContor: thread 1 old contor 8 new contor 9
incContor: thread 2 old contor 9 new contor 10
STOP incContor 2

incContor: thread 1 old contor 10 new contor 11
incContor: thread 1 old contor 11 new contor 12

verifContor: thread 0 contor 12
STOP verifContor

incContor: thread 1 old contor 12 new contor 13
incContor: thread 1 old contor 13 new contor 14
STOP incContor 1 
*/
