#include <pthread.h>
#include <semaphore.h>
#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>

#define nrLin 5
#define nrTr 13
pthread_mutex_t mutex=PTHREAD_MUTEX_INITIALIZER;
sem_t sem;
int poz[nrTr];
pthread_t tid[nrTr];
void list();
void* pass(void* ssind);

main(int argc, char* argv[])
{
  char* sind;
  int i;
  sem_init(&sem,0,nrLin);
  for (i=0;i < nrTr;i++) {
    sind=(char*) malloc(5*sizeof(char));
    sprintf(sind,"%d",i);
    pthread_create(&tid[i],NULL,pass,(void *)sind);
  }
  for (i=0;i < nrTr;i++)
    pthread_join(tid[i],NULL);
}

//Az llomsra berkezo vonatok kilistzsa
void list()
{
  int i;
  pthread_mutex_lock(&mutex);
  printf("Az allomasra erkezo vonatok:");
  for (i=0;i < nrTr ; i++)
    if (poz[i]==1)
      printf(" %d",i);
  printf("\n");
  pthread_mutex_unlock(&mutex);
}

// a szlat kezelo rutin
void* pass(void* ssind)
{
  char * sind = (char *)ssind;
  int sl,ind;
  ind=atoi((char*)sind);
  sem_wait(&sem);
  poz[ind]=1;
  list();
  sl=1+(int) (3.0*rand()/(RAND_MAX+1.0));
  sleep(sl);
  poz[ind]=2;
  sem_post(&sem);
  free(sind);
}

/*
Az allomasra erkezo vonatok: 0
Az allomasra erkezo vonatok: 0 1
Az allomasra erkezo vonatok: 0 1 2
Az allomasra erkezo vonatok: 0 1 2 3
Az allomasra erkezo vonatok: 0 1 2 3 4
Az allomasra erkezo vonatok: 0 2 3 4 5
Az allomasra erkezo vonatok: 5 8
Az allomasra erkezo vonatok: 5 7 8
Az allomasra erkezo vonatok: 5 6 7 8
Az allomasra erkezo vonatok: 5 6 7 8 9
Az allomasra erkezo vonatok: 6 7 8 9 10
Az allomasra erkezo vonatok: 7 8 9 10 11
Az allomasra erkezo vonatok: 7 10 11 12
*/
